﻿using System;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using System.Xml;

public partial class _Default : System.Web.UI.Page 
{
    internal int selectIndex
    {
        get
        {
            if (this.Session["Page_selectIndex"] == null)
                return -1;
            
            return Int32.Parse(this.Session["Page_selectIndex"].ToString());
        }
        set
        {
            this.Session["Page_selectIndex"] = value;
        }
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
        {
            carregaDadosXML();
            this.Session["Incluir"] = 0;

        }
    }
    protected void btnIncluir_Click(object sender, EventArgs e)
    {
        if ((int)Session["Incluir"] == 1)
        {
            if (TextBox1.Text.Equals("") || TextBox2.Text.Equals("") || TextBox3.Text.Equals(""))
            {
                this.RegisterClientScriptBlock("alertmessage", "<script>alert('Preencha os campos do formulário.')</script>");
            }
            else
            {
                XmlDocument xmldoc = new XmlDocument();
                xmldoc.Load(Server.MapPath(@"App_Data\poemas.xml"));
                //Cria um novo nó
                XmlElement novoelemento = xmldoc.CreateElement("poemas");
                XmlElement xmlAutor = xmldoc.CreateElement("autor");
                XmlElement xmlTitulo = xmldoc.CreateElement("titulo");
                XmlElement xmlConteudo = xmldoc.CreateElement("conteudo");

                xmlAutor.InnerText = this.TextBox1.Text.Trim();
                xmlTitulo.InnerText = this.TextBox2.Text.Trim();
                xmlConteudo.InnerText = this.TextBox3.Text.Trim();

                novoelemento.AppendChild(xmlAutor);
                novoelemento.AppendChild(xmlTitulo);
                novoelemento.AppendChild(xmlConteudo);

                xmldoc.DocumentElement.AppendChild(novoelemento);

                //xmlDoc.DocumentElement.InsertAfter(newElement,xmlDoc.DocumentElement.ChildNodes.Item(0));
                //xmlDoc.DocumentElement.InsertBefore(newElement,xmlDoc.DocumentElement.ChildNodes.Item(0));
                //save
                xmldoc.Save(Server.MapPath(@"App_Data\poemas.xml"));
                this.Session["Incluir"] = 0;
                carregaDadosXML();
            }
        }
        else
        {
            this.RegisterClientScriptBlock("alertmessage", "<script>alert('Limpe os campos do formulário para incluir um novo item.')</script>");
        }
    }
    /// <summary>
    /// carrega os dados xml
    /// </summary>
    private void carregaDadosXML()
    {
        DataSet ds = new DataSet();
        ds.ReadXml(Server.MapPath(@"App_Data\poemas.xml"));

        if (ds.Tables.Count > 0)
        {
            this.GridView1.DataSource = ds;
            this.GridView1.DataBind();
        }
    }

    protected void GridView1_SelectedIndexChanged(object sender, EventArgs e)
    {
        selectIndex = this.GridView1.SelectedIndex;
        procuraDadosXml(selectIndex);
        this.Session["Incluir"] = 0;
    }
    /// <summary>
    /// procura o indice definido por dataGridView1.CurrentRow.Index no arquivo xml 
    /// </summary>
    /// <param name="selectIndex"></param>
    private void procuraDadosXml(int selectedIndex)
    {
        XmlDocument xmldoc = new XmlDocument();
        xmldoc.Load(Server.MapPath(@"App_Data\poemas.xml"));
        XmlNodeList xmlnodelist = xmldoc.DocumentElement.ChildNodes;
        XmlNode xmlnode = xmlnodelist.Item(selectedIndex);
        this.TextBox1.Text = xmlnode["autor"].InnerText;
        this.TextBox2.Text = xmlnode["titulo"].InnerText;
        this.TextBox3.Text = xmlnode["conteudo"].InnerText;
    }
    protected void btnAlterar_Click(object sender, EventArgs e)
    {
        if (selectIndex == -1)
        {
            this.RegisterClientScriptBlock("alertmessage", "<script>alert('Selecione um item para alteração.')</script>");
        }
        else
        {
            XmlDocument xmldoc = new XmlDocument();
            xmldoc.Load(Server.MapPath(@"App_Data\poemas.xml"));
            XmlNode xmlnode = xmldoc.DocumentElement.ChildNodes.Item(selectIndex);

            xmlnode["autor"].InnerText = this.TextBox1.Text.Trim();
            xmlnode["titulo"].InnerText = this.TextBox2.Text.Trim();
            xmlnode["conteudo"].InnerText = this.TextBox3.Text.Trim();

            xmldoc.Save(Server.MapPath(@"App_Data\poemas.xml"));

            carregaDadosXML();
        }
    }
    protected void btnExcluir_Click(object sender, EventArgs e)
    {
        if (selectIndex == -1)
        {
           this.RegisterClientScriptBlock("alertmessage", "<script>alert('Selecione um item para excluir.')</script>");
        }
        else
        {
            XmlDocument xmldoc = new XmlDocument();
            xmldoc.Load(Server.MapPath(@"App_Data\poemas.xml"));
            XmlNode xmlnode = xmldoc.DocumentElement.ChildNodes.Item(selectIndex);
            xmlnode.ParentNode.RemoveChild(xmlnode);
            xmldoc.Save(Server.MapPath(@"App_Data\poemas.xml"));

            carregaDadosXML();
            this.TextBox1.Text = "";
            this.TextBox2.Text = "";
            this.TextBox3.Text = "";
        }
    }
    protected void btnLimpar_Click(object sender, EventArgs e)
    {
        this.TextBox1.Text = "";
        this.TextBox2.Text = "";
        this.TextBox3.Text = "";
        this.TextBox1.Text = "NOVO";
        this.TextBox1.Focus();
        Session["Incluir"] = 1;
    }
    protected void GridView1_PageIndexChanging(object sender, GridViewPageEventArgs e)
    {
        carregaDadosXML();
        GridView1.PageIndex = e.NewPageIndex;
        GridView1.DataBind();
    }
}
